-- Drag&Drop
-- Ограничения по перемещению формы на экране работаю корректно только, когда 
-- Align по X и Y - WIDGET_ALIGN_LOW
--

Global( "DragNDrop", {} ) -- список объектов для которых обрабатываем перетаскивание(окна, итемы и др.)
Global( "dndid", nil ) -- ИД окна, которое перетаскиваем
Global( "maxID", nil ) -- минимальный ИД из диапазона зарегестрированных в DNDInit
Global( "minID", nil ) -- максимальный ИД из диапазона зарегестрированных в DNDInit


-- Hack for AO 1.1.00 / 1.1.01
if common.GetGlobalConfigSection then
	if not avatar.GetEmotes then Global( "userMods", {} ) end
	userMods.GetGlobalConfigSection = common.GetGlobalConfigSection
	userMods.SetGlobalConfigSection = common.SetGlobalConfigSection
end


function DNDInit( wtReacting, wtMovable, ID )
	local dnd = {}
	dnd[ "ID" ] = ID
	dnd[ "wtReacting" ] = wtReacting
	dnd[ "wtMovable" ] = wtMovable
	dnd[ "IsPicked" ] = false
------------- загрузка позиции
	local AddonName = common.GetAddonName()
	local SectionName = AddonName .. "_Widget_" .. tostring(ID)
	local CFGPlacement = userMods.GetGlobalConfigSection( SectionName ) or wtMovable:GetPlacementPlain()
	wtMovable:SetPlacementPlain( CFGPlacement )
-------------
	dnd[ "Place" ] = CFGPlacement
	
	DragNDrop[ "Form" .. ID ] = dnd

	common.RegisterEventHandler( OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT" )
	common.RegisterEventHandler( OnEventDNDDragTo, "EVENT_DND_DRAG_TO" )
	common.RegisterEventHandler( OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT" )

	if not minID then minID = ID end
	if not maxID then maxID = ID end
	if minID > ID then minID = ID end
	if maxID < ID then maxID = ID end

	dndid = nil
	DNDReg(wtMovable, ID)
end

function DNDReg(wtWidget, ID)
	mission.DNDRegister( DragNDrop[ "Form" .. ID ].wtReacting , DND_WIDGET_MOVE * DND_CONTAINER_STEP + ID, true )

end

function DNDUnreg(ID)
------------ сохранение позиции
	DragNDrop[ "Form" .. ID ].Place = DragNDrop[ "Form" .. ID ].wtMovable:GetPlacementPlain()
	local AddonName = common.GetAddonName()
	local SectionName = AddonName .. "_Widget_" .. tostring( DragNDrop[ "Form" .. ID ].ID )
	userMods.SetGlobalConfigSection( SectionName, DragNDrop[ "Form" .. ID ].Place )
------------
	mission.DNDUnregister( DragNDrop[ "Form" .. ID ].wtReacting )
end

function OnEventDNDPickAttempt( params )
	dndid = math.mod( params.srcId, DND_CONTAINER_STEP )
-- ограничиваем ID
	if (( dndid > minID or dndid == minID) and (dndid < maxID or dndid == maxID)) then
		if math.mod( params.srcId, DND_CONTAINER_STEP ) == DragNDrop[ "Form" .. dndid ].ID then
			local DND = DragNDrop[ "Form" .. dndid ]
			DND.Screen = widgetsSystem:GetPosConverterParams()
			DND.Place = DragNDrop[ "Form" .. dndid ].wtMovable:GetPlacementPlain()
			DND.DeltaX = params.posX * DND.Screen.fullVirtualSizeX / DND.Screen.realSizeX - DND.Place.posX
			DND.DeltaY = params.posY * DND.Screen.fullVirtualSizeY / DND.Screen.realSizeY - DND.Place.posY
			common.SetCursor( "drag" )
			DND.IsPicked = true
		end
	else
		dndid = nil	
	end
end

function OnEventDNDDropAttempt( params )
	if dndid then
		if (( dndid > minID or dndid == minID) and (dndid < maxID or dndid == maxID)) then
			mission.DNDConfirmDropAttempt()
			common.SetCursor( "default" )
			DragNDrop[ "Form" .. dndid ].IsPicked = false
------------ сохранение позиции
	local AddonName = common.GetAddonName()
	local SectionName = AddonName .. "_Widget_" .. tostring( DragNDrop[ "Form" .. dndid ].ID )
--	LogInfo (SectionName)
	userMods.SetGlobalConfigSection( SectionName, DragNDrop[ "Form" .. dndid ].Place )
------------
		end
	end
	dndid = nil
end

function OnEventDNDDragTo( params )
	if dndid then
		if (( dndid > minID or dndid == minID) and (dndid < maxID or dndid == maxID)) then
			if DragNDrop[ "Form" .. dndid ].IsPicked == true then
				local screen = widgetsSystem:GetPosConverterParams()
				local place = DragNDrop[ "Form" .. dndid ].Place
				local DND = DragNDrop[ "Form" .. dndid ]
				place.posX = math.ceil ( params.posX * DND.Screen.fullVirtualSizeX / DND.Screen.realSizeX - DND.DeltaX )
				place.posY = math.ceil ( params.posY * DND.Screen.fullVirtualSizeY / DND.Screen.realSizeY - DND.DeltaY )
				if place.posX < 0 then place.posX = 0 end
				if place.posY < 0 then place.posY = 0 end
				if place.posX + place.sizeX > screen.fullVirtualSizeX then
					place.posX = screen.fullVirtualSizeX - place.sizeX
				end
				if place.posY + place.sizeY > screen.fullVirtualSizeY then
					place.posY = screen.fullVirtualSizeY - place.sizeY
				end
				DND.Place = place
				DND.wtMovable:SetPlacementPlain( DND.Place )
				common.SetCursor( "drag" )
			end
		end
	end
end
